﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.IO;

namespace InfragisticsScrollingTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Load();
            MainGrid.DataSource = Items;
        }

        int debugCounter = 0;
        public ObservableCollection<SimpleClass> Items { get; private set; }

        void Load()
        {
            int runSize = 1000;
            int counter = 1;
            Items = new ObservableCollection<SimpleClass>();
            for (int i = 1; i <= runSize; i++)
            {
                Items.Add(new SimpleClass(counter, "Deferred Scrolling Name " + counter.ToString()));
                counter++;
            }            
        }

        private void xamDataGrid1_ScrollChanged(object sender, ScrollChangedEventArgs e)
        {
            //I expect to see every visible row index come through here. If I thumb scroll all the way to the bottom, I do not.
            Infragistics.Windows.DataPresenter.Record[] ViewableRows = MainGrid.GetRecordsInView(false);            
            debugCounter++;
            WriteOutLocally(debugCounter.ToString() + ". " + ViewableRows[1].Index.ToString() + " - " + ViewableRows[ViewableRows.Length - 1].Index.ToString());
        }

        void WriteOutLocally(string s)
        {
            string fileLocation = @"C:\PaginatedGridThumbScrollingLog.txt";            
            TextWriter tw = new StreamWriter(fileLocation, true);            
            tw.WriteLine(s + " " + DateTime.Now.ToString());
            tw.Close();
        }
    }

  /*
   * Local file explaination.
   *
   * I wrote out to a local file because seting breakpoints on a scroll change event breaks the problem.
   * Below is a sample of what I see with this test app. I do not see 982-1000 come through on the scroll change.
   * This only happens on thumb scroll that goes all the way to the bottom or all the way to the top. If you
   * stop just short in either direction the problem doesnt happen.
   */
    
    //1. 1 - 18 6/14/2012 5:36:04 PM
    //2. 1 - 18 6/14/2012 5:36:04 PM
    //3. 1 - 18 6/14/2012 5:36:07 PM
    //4. 1 - 18 6/14/2012 5:36:07 PM
    //5. 1 - 18 6/14/2012 5:36:07 PM
    //6. 1 - 18 6/14/2012 5:36:07 PM
    //7. 1 - 18 6/14/2012 5:36:07 PM
    //8. 1 - 18 6/14/2012 5:36:07 PM
    //9. 1 - 18 6/14/2012 5:36:07 PM
    //10. 1 - 18 6/14/2012 5:36:07 PM
    //11. 1 - 18 6/14/2012 5:36:07 PM
    //12. 1 - 18 6/14/2012 5:36:07 PM
    //13. 1 - 18 6/14/2012 5:36:07 PM
    //14. 1 - 18 6/14/2012 5:36:07 PM
    //15. 1 - 18 6/14/2012 5:36:07 PM
    //16. 1 - 18 6/14/2012 5:36:07 PM
    //17. 1 - 18 6/14/2012 5:36:07 PM
    //18. 1 - 18 6/14/2012 5:36:07 PM
    //19. 1 - 18 6/14/2012 5:36:07 PM
    //20. 1 - 18 6/14/2012 5:36:07 PM
    //21. 1 - 18 6/14/2012 5:36:07 PM
    //22. 1 - 18 6/14/2012 5:36:07 PM
    //23. 1 - 18 6/14/2012 5:36:07 PM
    //24. 1 - 18 6/14/2012 5:36:07 PM
    //25. 1 - 18 6/14/2012 5:36:07 PM
    //26. 1 - 18 6/14/2012 5:36:07 PM
    //27. 1 - 18 6/14/2012 5:36:07 PM
    //28. 1 - 18 6/14/2012 5:36:07 PM
    //29. 1 - 18 6/14/2012 5:36:07 PM
    //30. 1 - 18 6/14/2012 5:36:07 PM
    //31. 1 - 18 6/14/2012 5:36:07 PM
    //32. 1 - 18 6/14/2012 5:36:07 PM
    //33. 1 - 18 6/14/2012 5:36:07 PM
    //34. 1 - 18 6/14/2012 5:36:07 PM
    //35. 1 - 18 6/14/2012 5:36:07 PM <-- im looking at records 982 - 1000 but it never hits the scroll change event.
}
